#!/usr/bin/php -Cq
<?php
- require_once(dirname(dirname(__FILE__)).'/lib/init-cmd.php');
+ require_once(dirname(dirname(__FILE__)).'/settings/settings.php');
+ require_once(CONST_BasePath.'/lib/init-cmd.php');
ini_set('memory_limit', '800M');
$aCMDOptions = array(
array('enable-diff-updates', '', 0, 1, 0, 0, 'bool', 'Turn on the code required to make diff updates work'),
array('enable-debug-statements', '', 0, 1, 0, 0, 'bool', 'Include debug warning statements in pgsql commands'),
array('ignore-errors', '', 0, 1, 0, 0, 'bool', 'Continue import even when errors in SQL are present (EXPERT)'),
- array('create-minimal-tables', '', 0, 1, 0, 0, 'bool', 'Create minimal main tables'),
array('create-tables', '', 0, 1, 0, 0, 'bool', 'Create main tables'),
array('create-partition-tables', '', 0, 1, 0, 0, 'bool', 'Create required partition tables'),
array('create-partition-functions', '', 0, 1, 0, 0, 'bool', 'Create required partition triggers'),
array('disable-token-precalc', '', 0, 1, 0, 0, 'bool', 'Disable name precalculation (EXPERT)'),
array('import-tiger-data', '', 0, 1, 0, 0, 'bool', 'Import tiger data (not included in \'all\')'),
array('calculate-postcodes', '', 0, 1, 0, 0, 'bool', 'Calculate postcode centroids'),
- array('create-roads', '', 0, 1, 0, 0, 'bool', ''),
array('osmosis-init', '', 0, 1, 0, 0, 'bool', 'Generate default osmosis configuration'),
array('index', '', 0, 1, 0, 0, 'bool', 'Index the data'),
array('index-noanalyse', '', 0, 1, 0, 0, 'bool', 'Do not perform analyse operations during index (EXPERT)'),
- array('index-output', '', 0, 1, 1, 1, 'string', 'File to dump index information to'),
array('create-search-indices', '', 0, 1, 0, 0, 'bool', 'Create additional indices required for search and update'),
array('create-website', '', 0, 1, 1, 1, 'realpath', 'Create symlinks to setup web directory'),
+ array('drop', '', 0, 1, 0, 0, 'bool', 'Drop tables needed for updates, making the database readonly (EXPERIMENTAL)'),
);
getCmdOpt($_SERVER['argv'], $aCMDOptions, $aCMDResult, true, true);
}
// Assume we can steal all the cache memory in the box (unless told otherwise)
- $iCacheMemory = (isset($aCMDResult['osm2pgsql-cache'])?$aCMDResult['osm2pgsql-cache']:getCacheMemoryMB());
- if ($iCacheMemory > getTotalMemoryMB())
+ if (isset($aCMDResult['osm2pgsql-cache']))
+ {
+ $iCacheMemory = $aCMDResult['osm2pgsql-cache'];
+ }
+ else
{
$iCacheMemory = getCacheMemoryMB();
- echo "WARNING: resetting cache memory to $iCacheMemory\n";
}
$aDSNInfo = DB::parseDSN(CONST_Database_DSN);
if (!isset($aDSNInfo['port']) || !$aDSNInfo['port']) $aDSNInfo['port'] = 5432;
- $fPostgisVersion = (float) CONST_Postgis_Version;
-
if ($aCMDResult['create-db'] || $aCMDResult['all'])
{
echo "Create DB\n";
$oDB =& getDB();
- $sVersionString = $oDB->getOne('select version()');
- preg_match('#PostgreSQL ([0-9]+)[.]([0-9]+)[.]([0-9]+) #', $sVersionString, $aMatches);
- if (CONST_Postgresql_Version != $aMatches[1].'.'.$aMatches[2])
+ $fPostgresVersion = getPostgresVersion($oDB);
+ echo 'Postgres version found: '.$fPostgresVersion."\n";
+
+ if ($fPostgresVersion < 9.1)
{
- echo "ERROR: PostgreSQL version is not correct. Expected ".CONST_Postgresql_Version." found ".$aMatches[1].'.'.$aMatches[2]."\n";
- exit;
+ fail("Minimum supported version of Postgresql is 9.1.");
}
- passthru('createlang plpgsql -p '.$aDSNInfo['port'].' '.$aDSNInfo['database']);
- $pgver = (float) CONST_Postgresql_Version;
- if ($pgver < 9.1) {
- pgsqlRunScriptFile(CONST_Path_Postgresql_Contrib.'/hstore.sql');
- pgsqlRunScriptFile(CONST_BasePath.'/sql/hstore_compatability_9_0.sql');
- } else {
- pgsqlRunScript('CREATE EXTENSION hstore');
- }
+ pgsqlRunScript('CREATE EXTENSION IF NOT EXISTS hstore');
+ pgsqlRunScript('CREATE EXTENSION IF NOT EXISTS postgis');
- if ($fPostgisVersion < 2.0) {
- pgsqlRunScriptFile(CONST_Path_Postgresql_Postgis.'/postgis.sql');
- pgsqlRunScriptFile(CONST_Path_Postgresql_Postgis.'/spatial_ref_sys.sql');
- } else {
- pgsqlRunScript('CREATE EXTENSION postgis');
+ // For extratags and namedetails the hstore_to_json converter is
+ // needed which is only available from Postgresql 9.3+. For older
+ // versions add a dummy function that returns nothing.
+ $iNumFunc = $oDB->getOne("select count(*) from pg_proc where proname = 'hstore_to_json'");
+ if (PEAR::isError($iNumFunc))
+ {
+ fail("Cannot query stored procedures.", $iNumFunc);
}
- if ($fPostgisVersion < 2.1) {
- // Function was renamed in 2.1 and throws an annoying deprecation warning
- pgsqlRunScript('ALTER FUNCTION st_line_interpolate_point(geometry, double precision) RENAME TO ST_LineInterpolatePoint');
+ if ($iNumFunc == 0)
+ {
+ pgsqlRunScript("create function hstore_to_json(dummy hstore) returns text AS 'select null::text' language sql immutable");
+ echo "WARNING: Postgresql is too old. extratags and namedetails API not available.";
}
- $sVersionString = $oDB->getOne('select postgis_full_version()');
- preg_match('#POSTGIS="([0-9]+)[.]([0-9]+)[.]([0-9]+)( r([0-9]+))?"#', $sVersionString, $aMatches);
- if (CONST_Postgis_Version != $aMatches[1].'.'.$aMatches[2])
+
+ $fPostgisVersion = getPostgisVersion($oDB);
+ echo 'Postgis version found: '.$fPostgisVersion."\n";
+
+ if ($fPostgisVersion < 2.1)
{
- echo "ERROR: PostGIS version is not correct. Expected ".CONST_Postgis_Version." found ".$aMatches[1].'.'.$aMatches[2]."\n";
- exit;
+ // Function was renamed in 2.1 and throws an annoying deprecation warning
+ pgsqlRunScript('ALTER FUNCTION st_line_interpolate_point(geometry, double precision) RENAME TO ST_LineInterpolatePoint');
}
pgsqlRunScriptFile(CONST_BasePath.'/data/country_name.sql');
{
echo "WARNING: external UK postcode table not found.\n";
}
- pgsqlRunScriptFile(CONST_BasePath.'/data/us_statecounty.sql');
- pgsqlRunScriptFile(CONST_BasePath.'/data/us_state.sql');
- pgsqlRunScriptFile(CONST_BasePath.'/data/us_postcode.sql');
+ if (CONST_Use_Extra_US_Postcodes)
+ {
+ pgsqlRunScriptFile(CONST_BasePath.'/data/us_postcode.sql');
+ }
if ($aCMDResult['no-partitions'])
{
{
$osm2pgsql .= ' --flat-nodes '.CONST_Osm2pgsql_Flatnode_File;
}
- $osm2pgsql .= ' -lsc -O gazetteer --hstore';
+ if (CONST_Tablespace_Osm2pgsql_Data)
+ $osm2pgsql .= ' --tablespace-slim-data '.CONST_Tablespace_Osm2pgsql_Data;
+ if (CONST_Tablespace_Osm2pgsql_Index)
+ $osm2pgsql .= ' --tablespace-slim-index '.CONST_Tablespace_Osm2pgsql_Index;
+ if (CONST_Tablespace_Place_Data)
+ $osm2pgsql .= ' --tablespace-main-data '.CONST_Tablespace_Place_Data;
+ if (CONST_Tablespace_Place_Index)
+ $osm2pgsql .= ' --tablespace-main-index '.CONST_Tablespace_Place_Index;
+ $osm2pgsql .= ' -lsc -O gazetteer --hstore --number-processes 1';
$osm2pgsql .= ' -C '.$iCacheMemory;
$osm2pgsql .= ' -P '.$aDSNInfo['port'];
$osm2pgsql .= ' -d '.$aDSNInfo['database'].' '.$aCMDResult['osm-file'];
{
echo "Functions\n";
$bDidSomething = true;
- if (!file_exists(CONST_BasePath.'/module/nominatim.so')) fail("nominatim module not built");
- $sTemplate = file_get_contents(CONST_BasePath.'/sql/functions.sql');
- $sTemplate = str_replace('{modulepath}', CONST_BasePath.'/module', $sTemplate);
- if ($aCMDResult['enable-diff-updates']) $sTemplate = str_replace('RETURN NEW; -- @DIFFUPDATES@', '--', $sTemplate);
- if ($aCMDResult['enable-debug-statements']) $sTemplate = str_replace('--DEBUG:', '', $sTemplate);
- if (CONST_Limit_Reindexing) $sTemplate = str_replace('--LIMIT INDEXING:', '', $sTemplate);
- pgsqlRunScript($sTemplate);
- if ($fPostgisVersion < 2.0) {
- echo "Helper functions for postgis < 2.0\n";
- $sTemplate = file_get_contents(CONST_BasePath.'/sql/postgis_15_aux.sql');
- } else {
- echo "Helper functions for postgis >= 2.0\n";
- $sTemplate = file_get_contents(CONST_BasePath.'/sql/postgis_20_aux.sql');
- }
- pgsqlRunScript($sTemplate);
+ if (!file_exists(CONST_InstallPath.'/module/nominatim.so')) fail("nominatim module not built");
+ create_sql_functions($aCMDResult);
}
- if ($aCMDResult['create-minimal-tables'])
+ if ($aCMDResult['create-tables'] || $aCMDResult['all'])
{
- echo "Minimal Tables\n";
$bDidSomething = true;
- pgsqlRunScriptFile(CONST_BasePath.'/sql/tables-minimal.sql');
-
- $sScript = '';
-
- // Backstop the import process - easliest possible import id
- $sScript .= "insert into import_npi_log values (18022);\n";
-
- $hFile = @fopen(CONST_BasePath.'/settings/partitionedtags.def', "r");
- if (!$hFile) fail('unable to open list of partitions: '.CONST_BasePath.'/settings/partitionedtags.def');
-
- while (($sLine = fgets($hFile, 4096)) !== false && $sLine && substr($sLine,0,1) !='#')
- {
- list($sClass, $sType) = explode(' ', trim($sLine));
- $sScript .= "create table place_classtype_".$sClass."_".$sType." as ";
- $sScript .= "select place_id as place_id,geometry as centroid from placex limit 0;\n";
-
- $sScript .= "CREATE INDEX idx_place_classtype_".$sClass."_".$sType."_centroid ";
- $sScript .= "ON place_classtype_".$sClass."_".$sType." USING GIST (centroid);\n";
- $sScript .= "CREATE INDEX idx_place_classtype_".$sClass."_".$sType."_place_id ";
- $sScript .= "ON place_classtype_".$sClass."_".$sType." USING btree(place_id);\n";
- }
- fclose($hFile);
- pgsqlRunScript($sScript);
- }
-
- if ($aCMDResult['create-tables'] || $aCMDResult['all'])
- {
echo "Tables\n";
- $bDidSomething = true;
- pgsqlRunScriptFile(CONST_BasePath.'/sql/tables.sql');
+ $sTemplate = file_get_contents(CONST_BasePath.'/sql/tables.sql');
+ $sTemplate = str_replace('{www-user}', CONST_Database_Web_User, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:address-data}',
+ CONST_Tablespace_Address_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:address-index}',
+ CONST_Tablespace_Address_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:search-data}',
+ CONST_Tablespace_Search_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:search-index}',
+ CONST_Tablespace_Search_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-data}',
+ CONST_Tablespace_Aux_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-index}',
+ CONST_Tablespace_Aux_Index, $sTemplate);
+ pgsqlRunScript($sTemplate, false);
// re-run the functions
- $sTemplate = file_get_contents(CONST_BasePath.'/sql/functions.sql');
- $sTemplate = str_replace('{modulepath}',CONST_BasePath.'/module', $sTemplate);
- pgsqlRunScript($sTemplate);
+ echo "Functions\n";
+ create_sql_functions($aCMDResult);
}
if ($aCMDResult['create-partition-tables'] || $aCMDResult['all'])
if (!$aCMDResult['no-partitions']) $aPartitions[] = 0;
$sTemplate = file_get_contents(CONST_BasePath.'/sql/partition-tables.src.sql');
+ $sTemplate = replace_tablespace('{ts:address-data}',
+ CONST_Tablespace_Address_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:address-index}',
+ CONST_Tablespace_Address_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:search-data}',
+ CONST_Tablespace_Search_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:search-index}',
+ CONST_Tablespace_Search_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-data}',
+ CONST_Tablespace_Aux_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-index}',
+ CONST_Tablespace_Aux_Index, $sTemplate);
preg_match_all('#^-- start(.*?)^-- end#ms', $sTemplate, $aMatches, PREG_SET_ORDER);
foreach($aMatches as $aMatch)
{
pgsqlRunScript('ANALYSE');
}
- if ($aCMDResult['create-roads'])
- {
- $bDidSomething = true;
-
- $oDB =& getDB();
- $aDBInstances = array();
- for($i = 0; $i < $iInstances; $i++)
- {
- $aDBInstances[$i] =& getDB(true);
- if (!pg_query($aDBInstances[$i]->connection, 'set enable_bitmapscan = off')) fail(pg_last_error($oDB->connection));
- $sSQL = 'select count(*) from (select insertLocationRoad(partition, place_id, calculated_country_code, geometry) from ';
- $sSQL .= 'placex where osm_id % '.$iInstances.' = '.$i.' and rank_search between 26 and 27 and class = \'highway\') as x ';
- if ($aCMDResult['verbose']) echo "$sSQL\n";
- if (!pg_send_query($aDBInstances[$i]->connection, $sSQL)) fail(pg_last_error($oDB->connection));
- }
- $bAnyBusy = true;
- while($bAnyBusy)
- {
- $bAnyBusy = false;
- for($i = 0; $i < $iInstances; $i++)
- {
- if (pg_connection_busy($aDBInstances[$i]->connection)) $bAnyBusy = true;
- }
- sleep(1);
- echo '.';
- }
- echo "\n";
- }
-
if ($aCMDResult['import-tiger-data'])
{
$bDidSomething = true;
- pgsqlRunScriptFile(CONST_BasePath.'/sql/tiger_import_start.sql');
+ $sTemplate = file_get_contents(CONST_BasePath.'/sql/tiger_import_start.sql');
+ $sTemplate = str_replace('{www-user}', CONST_Database_Web_User, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-data}',
+ CONST_Tablespace_Aux_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-index}',
+ CONST_Tablespace_Aux_Index, $sTemplate);
+ pgsqlRunScript($sTemplate, false);
$aDBInstances = array();
for($i = 0; $i < $iInstances; $i++)
$aDBInstances[$i] =& getDB(true);
}
- foreach(glob(CONST_BasePath.'/data/tiger2011/*.sql') as $sFile)
+ foreach(glob(CONST_Tiger_Data_Path.'/*.sql') as $sFile)
{
echo $sFile.': ';
$hFile = fopen($sFile, "r");
}
echo "Creating indexes\n";
- pgsqlRunScriptFile(CONST_BasePath.'/sql/tiger_import_finish.sql');
+ $sTemplate = file_get_contents(CONST_BasePath.'/sql/tiger_import_finish.sql');
+ $sTemplate = str_replace('{www-user}', CONST_Database_Web_User, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-data}',
+ CONST_Tablespace_Aux_Data, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-index}',
+ CONST_Tablespace_Aux_Index, $sTemplate);
+ pgsqlRunScript($sTemplate, false);
}
if ($aCMDResult['calculate-postcodes'] || $aCMDResult['all'])
$sSQL .= "from placex where postcode is not null group by calculated_country_code,postcode) as x";
if (!pg_query($oDB->connection, $sSQL)) fail(pg_last_error($oDB->connection));
- $sSQL = "insert into placex (osm_type,osm_id,class,type,postcode,calculated_country_code,geometry) ";
- $sSQL .= "select 'P',nextval('seq_postcodes'),'place','postcode',postcode,'us',";
- $sSQL .= "ST_SetSRID(ST_Point(x,y),4326) as geometry from us_postcode";
- if (!pg_query($oDB->connection, $sSQL)) fail(pg_last_error($oDB->connection));
+ if (CONST_Use_Extra_US_Postcodes)
+ {
+ $sSQL = "insert into placex (osm_type,osm_id,class,type,postcode,calculated_country_code,geometry) ";
+ $sSQL .= "select 'P',nextval('seq_postcodes'),'place','postcode',postcode,'us',";
+ $sSQL .= "ST_SetSRID(ST_Point(x,y),4326) as geometry from us_postcode";
+ if (!pg_query($oDB->connection, $sSQL)) fail(pg_last_error($oDB->connection));
+ }
}
- if ($aCMDResult['osmosis-init'] || $aCMDResult['all'])
+ if ($aCMDResult['osmosis-init'] || ($aCMDResult['all'] && !$aCMDResult['drop'])) // no use doing osmosis-init when dropping update tables
{
$bDidSomething = true;
$oDB =& getDB();
}
else
{
- if (file_exists(CONST_BasePath.'/settings/configuration.txt'))
+ if (file_exists(CONST_InstallPath.'/settings/configuration.txt'))
{
echo "settings/configuration.txt already exists\n";
}
else
{
- passthru(CONST_Osmosis_Binary.' --read-replication-interval-init '.CONST_BasePath.'/settings');
+ passthru(CONST_Osmosis_Binary.' --read-replication-interval-init '.CONST_InstallPath.'/settings');
// update osmosis configuration.txt with our settings
- passthru("sed -i 's!baseUrl=.*!baseUrl=".CONST_Replication_Url."!' ".CONST_BasePath.'/settings/configuration.txt');
- passthru("sed -i 's:maxInterval = .*:maxInterval = ".CONST_Replication_MaxInterval.":' ".CONST_BasePath.'/settings/configuration.txt');
+ passthru("sed -i 's!baseUrl=.*!baseUrl=".CONST_Replication_Url."!' ".CONST_InstallPath.'/settings/configuration.txt');
+ passthru("sed -i 's:maxInterval = .*:maxInterval = ".CONST_Replication_MaxInterval.":' ".CONST_InstallPath.'/settings/configuration.txt');
}
// Find the last node in the DB
- $iLastOSMID = $oDB->getOne("select max(id) from planet_osm_nodes");
+ $iLastOSMID = $oDB->getOne("select max(osm_id) from place where osm_type = 'N'");
// Lookup the timestamp that node was created (less 3 hours for margin for changsets to be closed)
$sLastNodeURL = 'http://www.openstreetmap.org/api/0.6/node/'.$iLastOSMID."/1";
// Search for the correct state file - uses file timestamps so need to sort by date descending
$sRepURL = CONST_Replication_Url."/";
- $sRep = file_get_contents($sRepURL."?C=M;O=D");
+ $sRep = file_get_contents($sRepURL."?C=M;O=D;F=1");
// download.geofabrik.de: <a href="000/">000/</a></td><td align="right">26-Feb-2013 11:53 </td>
- // planet.openstreetmap.org: <a href="273/">273/</a> 22-Mar-2013 07:41 -
- preg_match_all('#<a href="[0-9]{3}/">([0-9]{3}/)</a>.*(([0-9]{2})-([A-z]{3})-([0-9]{4}) ([0-9]{2}):([0-9]{2}))#', $sRep, $aRepMatches, PREG_SET_ORDER);
- $aPrevRepMatch = false;
- foreach($aRepMatches as $aRepMatch)
+ // planet.openstreetmap.org: <a href="273/">273/</a> 2013-03-11 07:41 -
+ preg_match_all('#<a href="[0-9]{3}/">([0-9]{3}/)</a>\s*([-0-9a-zA-Z]+ [0-9]{2}:[0-9]{2})#', $sRep, $aRepMatches, PREG_SET_ORDER);
+ if ($aRepMatches)
{
- if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
- $aPrevRepMatch = $aRepMatch;
- }
- if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
+ $aPrevRepMatch = false;
+ foreach($aRepMatches as $aRepMatch)
+ {
+ if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
+ $aPrevRepMatch = $aRepMatch;
+ }
+ if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
- $sRepURL .= $aRepMatch[1];
- $sRep = file_get_contents($sRepURL."?C=M;O=D");
- preg_match_all('#<a href="[0-9]{3}/">([0-9]{3}/)</a>.*(([0-9]{2})-([A-z]{3})-([0-9]{4}) ([0-9]{2}):([0-9]{2}))#', $sRep, $aRepMatches, PREG_SET_ORDER);
- $aPrevRepMatch = false;
- foreach($aRepMatches as $aRepMatch)
- {
- if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
- $aPrevRepMatch = $aRepMatch;
- }
- if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
+ $sRepURL .= $aRepMatch[1];
+ $sRep = file_get_contents($sRepURL."?C=M;O=D;F=1");
+ preg_match_all('#<a href="[0-9]{3}/">([0-9]{3}/)</a>\s*([-0-9a-zA-Z]+ [0-9]{2}:[0-9]{2})#', $sRep, $aRepMatches, PREG_SET_ORDER);
+ $aPrevRepMatch = false;
+ foreach($aRepMatches as $aRepMatch)
+ {
+ if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
+ $aPrevRepMatch = $aRepMatch;
+ }
+ if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
- $sRepURL .= $aRepMatch[1];
- $sRep = file_get_contents($sRepURL."?C=M;O=D");
- preg_match_all('#<a href="[0-9]{3}.state.txt">([0-9]{3}).state.txt</a>.*(([0-9]{2})-([A-z]{3})-([0-9]{4}) ([0-9]{2}):([0-9]{2}))#', $sRep, $aRepMatches, PREG_SET_ORDER);
- $aPrevRepMatch = false;
- foreach($aRepMatches as $aRepMatch)
+ $sRepURL .= $aRepMatch[1];
+ $sRep = file_get_contents($sRepURL."?C=M;O=D;F=1");
+ preg_match_all('#<a href="[0-9]{3}.state.txt">([0-9]{3}).state.txt</a>\s*([-0-9a-zA-Z]+ [0-9]{2}:[0-9]{2})#', $sRep, $aRepMatches, PREG_SET_ORDER);
+ $aPrevRepMatch = false;
+ foreach($aRepMatches as $aRepMatch)
+ {
+ if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
+ $aPrevRepMatch = $aRepMatch;
+ }
+ if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
+
+ $sRepURL .= $aRepMatch[1].'.state.txt';
+ echo "Getting state file: $sRepURL\n";
+ $sStateFile = file_get_contents($sRepURL);
+ if (!$sStateFile || strlen($sStateFile) > 1000) fail("unable to obtain state file");
+ file_put_contents(CONST_InstallPath.'/settings/state.txt', $sStateFile);
+ echo "Updating DB status\n";
+ pg_query($oDB->connection, 'TRUNCATE import_status');
+ $sSQL = "INSERT INTO import_status VALUES('".$aRepMatch[2]."')";
+ pg_query($oDB->connection, $sSQL);
+ }
+ else
{
- if (strtotime($aRepMatch[2]) < $iLastNodeTimestamp) break;
- $aPrevRepMatch = $aRepMatch;
+ if (!$aCMDResult['all'])
+ {
+ fail("Cannot read state file directory.");
+ }
}
- if ($aPrevRepMatch) $aRepMatch = $aPrevRepMatch;
-
- $sRepURL .= $aRepMatch[1].'.state.txt';
- echo "Getting state file: $sRepURL\n";
- $sStateFile = file_get_contents($sRepURL);
- if (!$sStateFile || strlen($sStateFile) > 1000) fail("unable to obtain state file");
- file_put_contents(CONST_BasePath.'/settings/state.txt', $sStateFile);
- echo "Updating DB status\n";
- pg_query($oDB->connection, 'TRUNCATE import_status');
- $sSQL = "INSERT INTO import_status VALUES('".$aRepMatch[2]."')";
- pg_query($oDB->connection, $sSQL);
}
}
{
$bDidSomething = true;
$sOutputFile = '';
- if (isset($aCMDResult['index-output'])) $sOutputFile = ' -F '.$aCMDResult['index-output'];
- $sBaseCmd = CONST_BasePath.'/nominatim/nominatim -i -d '.$aDSNInfo['database'].' -P '.$aDSNInfo['port'].' -t '.$iInstances.$sOutputFile;
+ $sBaseCmd = CONST_InstallPath.'/nominatim/nominatim -i -d '.$aDSNInfo['database'].' -P '.$aDSNInfo['port'].' -t '.$iInstances.$sOutputFile;
passthruCheckReturn($sBaseCmd.' -R 4');
if (!$aCMDResult['index-noanalyse']) pgsqlRunScript('ANALYSE');
passthruCheckReturn($sBaseCmd.' -r 5 -R 25');
{
echo "Search indices\n";
$bDidSomething = true;
- $oDB =& getDB();
- $sSQL = 'select distinct partition from country_name';
- $aPartitions = $oDB->getCol($sSQL);
- if (PEAR::isError($aPartitions))
- {
- fail($aPartitions->getMessage());
- }
- if (!$aCMDResult['no-partitions']) $aPartitions[] = 0;
$sTemplate = file_get_contents(CONST_BasePath.'/sql/indices.src.sql');
- preg_match_all('#^-- start(.*?)^-- end#ms', $sTemplate, $aMatches, PREG_SET_ORDER);
- foreach($aMatches as $aMatch)
- {
- $sResult = '';
- foreach($aPartitions as $sPartitionName)
- {
- $sResult .= str_replace('-partition-', $sPartitionName, $aMatch[1]);
- }
- $sTemplate = str_replace($aMatch[0], $sResult, $sTemplate);
- }
+ $sTemplate = replace_tablespace('{ts:address-index}',
+ CONST_Tablespace_Address_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:search-index}',
+ CONST_Tablespace_Search_Index, $sTemplate);
+ $sTemplate = replace_tablespace('{ts:aux-index}',
+ CONST_Tablespace_Aux_Index, $sTemplate);
pgsqlRunScript($sTemplate);
}
fail("Target directory does not exist.");
}
- @symlink(CONST_BasePath.'/website/details.php', $sTargetDir.'/details.php');
- @symlink(CONST_BasePath.'/website/reverse.php', $sTargetDir.'/reverse.php');
- @symlink(CONST_BasePath.'/website/search.php', $sTargetDir.'/search.php');
- @symlink(CONST_BasePath.'/website/search.php', $sTargetDir.'/index.php');
- @symlink(CONST_BasePath.'/website/deletable.php', $sTargetDir.'/deletable.php');
- @symlink(CONST_BasePath.'/website/polygons.php', $sTargetDir.'/polygons.php');
- @symlink(CONST_BasePath.'/website/status.php', $sTargetDir.'/status.php');
+ @symlink(CONST_InstallPath.'/website/details.php', $sTargetDir.'/details.php');
+ @symlink(CONST_InstallPath.'/website/reverse.php', $sTargetDir.'/reverse.php');
+ @symlink(CONST_InstallPath.'/website/search.php', $sTargetDir.'/search.php');
+ @symlink(CONST_InstallPath.'/website/search.php', $sTargetDir.'/index.php');
+ @symlink(CONST_InstallPath.'/website/lookup.php', $sTargetDir.'/lookup.php');
+ @symlink(CONST_InstallPath.'/website/deletable.php', $sTargetDir.'/deletable.php');
+ @symlink(CONST_InstallPath.'/website/polygons.php', $sTargetDir.'/polygons.php');
+ @symlink(CONST_InstallPath.'/website/status.php', $sTargetDir.'/status.php');
@symlink(CONST_BasePath.'/website/images', $sTargetDir.'/images');
@symlink(CONST_BasePath.'/website/js', $sTargetDir.'/js');
@symlink(CONST_BasePath.'/website/css', $sTargetDir.'/css');
}
}
+ if ($aCMDResult['drop'])
+ {
+ // The implementation is potentially a bit dangerous because it uses
+ // a positive selection of tables to keep, and deletes everything else.
+ // Including any tables that the unsuspecting user might have manually
+ // created. USE AT YOUR OWN PERIL.
+ $bDidSomething = true;
+
+ // tables we want to keep. everything else goes.
+ $aKeepTables = array(
+ "*columns",
+ "import_polygon_*",
+ "import_status",
+ "place_addressline",
+ "location_property*",
+ "placex",
+ "search_name",
+ "seq_*",
+ "word",
+ "query_log",
+ "new_query_log",
+ "gb_postcode",
+ "spatial_ref_sys",
+ "country_name",
+ "place_classtype_*"
+ );
+
+ $oDB =& getDB();
+ $aDropTables = array();
+ $aHaveTables = $oDB->getCol("SELECT tablename FROM pg_tables WHERE schemaname='public'");
+ if (PEAR::isError($aHaveTables))
+ {
+ fail($aPartitions->getMessage());
+ }
+ foreach($aHaveTables as $sTable)
+ {
+ $bFound = false;
+ foreach ($aKeepTables as $sKeep)
+ {
+ if (fnmatch($sKeep, $sTable))
+ {
+ $bFound = true;
+ break;
+ }
+ }
+ if (!$bFound) array_push($aDropTables, $sTable);
+ }
+
+ foreach ($aDropTables as $sDrop)
+ {
+ if ($aCMDResult['verbose']) echo "dropping table $sDrop\n";
+ @pg_query($oDB->connection, "DROP TABLE $sDrop CASCADE");
+ // ignore warnings/errors as they might be caused by a table having
+ // been deleted already by CASCADE
+ }
+
+ if (!is_null(CONST_Osm2pgsql_Flatnode_File))
+ {
+ if ($aCMDResult['verbose']) echo "deleting ".CONST_Osm2pgsql_Flatnode_File."\n";
+ unlink(CONST_Osm2pgsql_Flatnode_File);
+ }
+ }
+
if (!$bDidSomething)
{
showUsage($aCMDOptions, true);
}
- function pgsqlRunScript($sScript)
+ function pgsqlRunScript($sScript, $bfatal = true)
{
global $aCMDResult;
// Convert database DSN to psql parameters
$aDSNInfo = DB::parseDSN(CONST_Database_DSN);
if (!isset($aDSNInfo['port']) || !$aDSNInfo['port']) $aDSNInfo['port'] = 5432;
$sCMD = 'psql -p '.$aDSNInfo['port'].' -d '.$aDSNInfo['database'];
- if (!$aCMDResult['ignore-errors'])
+ if ($bfatal && !$aCMDResult['ignore-errors'])
$sCMD .= ' -v ON_ERROR_STOP=1';
$aDescriptors = array(
0 => array('pipe', 'r'),
}
fclose($ahPipes[0]);
$iReturn = proc_close($hProcess);
- if ($iReturn > 0)
+ if ($bfatal && $iReturn > 0)
{
fail("pgsql returned with error code ($iReturn)");
}
passthru($cmd, $result);
if ($result != 0) fail('Error executing external command: '.$cmd);
}
+
+ function replace_tablespace($sTemplate, $sTablespace, $sSql)
+ {
+ if ($sTablespace)
+ $sSql = str_replace($sTemplate, 'TABLESPACE "'.$sTablespace.'"',
+ $sSql);
+ else
+ $sSql = str_replace($sTemplate, '', $sSql);
+
+ return $sSql;
+ }
+
+ function create_sql_functions($aCMDResult)
+ {
+ $sTemplate = file_get_contents(CONST_BasePath.'/sql/functions.sql');
+ $sTemplate = str_replace('{modulepath}', CONST_InstallPath.'/module', $sTemplate);
+ if ($aCMDResult['enable-diff-updates'])
+ {
+ $sTemplate = str_replace('RETURN NEW; -- %DIFFUPDATES%', '--', $sTemplate);
+ }
+ if ($aCMDResult['enable-debug-statements'])
+ {
+ $sTemplate = str_replace('--DEBUG:', '', $sTemplate);
+ }
+ if (CONST_Limit_Reindexing)
+ {
+ $sTemplate = str_replace('--LIMIT INDEXING:', '', $sTemplate);
+ }
+ if (!CONST_Use_US_Tiger_Data)
+ {
+ $sTemplate = str_replace('-- %NOTIGERDATA% ', '', $sTemplate);
+ }
+ if (!CONST_Use_Aux_Location_data)
+ {
+ $sTemplate = str_replace('-- %NOAUXDATA% ', '', $sTemplate);
+ }
+ pgsqlRunScript($sTemplate);
+
+ }
+